﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Charts;
using System.ComponentModel;

namespace DataChart_Scatter_drawing
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        private Rect rect;
        public Rect HighlighRect
        {
            get
            {
                return rect; 
            }
            set
            {
                rect = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("HighlighRect"));
                }
            }
        }

        public class SimpleIntDataPoint
        {
            public double X { get; set; }
            public double Y { get; set; }
        }

        public ObservableCollection<SimpleIntDataPoint> Data { get; set; }

        private SimpleIntDataPoint SpiralDataPoint(int n, int N, double f, double t)
        {
            double p = (double)n / (double)(N - 1);
            double theta = f * 2.0 * Math.PI * p;
            double radius = (0.1 + 0.9 * p) * t;

            return new SimpleIntDataPoint() { X = radius * Math.Cos(theta), Y = radius * Math.Sin(theta) };
        }

        public MainWindow()
        {
            InitializeComponent();

            int count = 1000;
            Data = new ObservableCollection<SimpleIntDataPoint>();
            for (int i = 0; i < count; ++i)
            {
                Data.Add(SpiralDataPoint(i, count, 4, 1.0));
            }            
            xamDataChart1.DataContext = this;
        }
                

        public void REFRESH()
        {
            NumericXAxis xAxis = xamDataChart1.Axes["XAxis"] as NumericXAxis;
            NumericYAxis yAxis = xamDataChart1.Axes["YAxis"] as NumericYAxis;
            Rect windowRect = xamDataChart1.WindowRect;
            Canvas theCanvas = xamDataChart1.PlotAreaBackgroundContent as Canvas;
            Rect viewportRect = new Rect(0, 0, theCanvas.ActualWidth, theCanvas.ActualHeight);

            double left = xAxis.GetScaledValue(0, windowRect, viewportRect);
            double right = xAxis.GetScaledValue(0.3, windowRect, viewportRect);
            double top = yAxis.GetScaledValue(0.3, windowRect, viewportRect);
            
            double bottom = yAxis.GetScaledValue(0, windowRect, viewportRect);

            HighlighRect = new Rect(left, top, right - left, bottom - top);
        }


        private void theCanvas_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            REFRESH();          
        }

        private void Axis_RangeChanged(object sender, AxisRangeChangedEventArgs e)
        {
            REFRESH();
        }

        private void xamDataChart1_WindowRectChanged(object sender, Infragistics.RectChangedEventArgs e)
        {
            REFRESH();
        }
    }
}
